{$M,2048,0,0}

program intspy;

(*****************************************************************************
                  Nick Walter computing (c) 1993 TurboSoft
******************************************************************************)

uses dos;
{$I-,F-,S-,V-}

const

SwapVectorsCnt=6; {!!!}

SpyInt: byte=$33;

BufS: word=0;
BufScan: word=0;
BufMax=2000;
StackLength=2048; {  !!! Look Up ($M,2048,0,0) !!!  }

HEXCHARS: array [0..15] of char = '0123456789ABCDEF';

type TSpy=record
	CallOffs: word;
	CallSeg: word;
	RAX: word;
	RBX: word;
	RCX: word;
	RDX: word;
	RSI: word;
	RDI: word;
	RES: word;
	RDS: word;
	RSP: word;
	RSS: word;
	end;
var
PName: NameStr;
FDir: DirStr;
FName: NameStr;
FExt: ExtStr;
Buf: array[0..BufMax-1] of TSpy;
Timer: word;
ch: char;
DFile: File;
i,j: word;
Str1: string;

procedure Resident; forward;
procedure main; forward;

procedure FileName; assembler;
asm
	db 0,0,0,0,0,0,0,0,0
end;

procedure ScanKeys; assembler;
asm
@ShiftKey: db 08h {Alt}
@ScanKey:  db 01h {Esc}
end;


function LTime: word; assembler;
asm
	push es
	mov ax,040h
	mov es,ax
	cli
	mov ax,es:[06Ch]
	sti
	pop es
end;

procedure GetScrSeg; assembler;
asm
	mov ah,15
	int 10h
	cmp al,2
	jz @2
	cmp al,3
	jz @2
	cmp al,7
	mov ax,0b000h
	jz @1
	stc
	jmp @1
@2:
	mov ax,0b800h
@1:
end;

procedure Mes1; assembler;
asm
	dw 12 {Length}
	db 'PLEASE WAIT',0
end;

procedure Mes2; assembler;
asm
	dw 30 {Length}
	db 'INTSPY REMOVED! PRESS ANY KEY',0
end;

procedure Mes3; assembler;
asm
	dw 34 {Length}
	db 'CAN''T REMOVE INTSPY! PRESS ANY KEY',0
end;

procedure SwapScrSave; assembler;
asm
	jmp @2
@1:
	dd 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dd 0,0,0,0,0,0,0,0
@2:
	call GetScrSeg
	jc @3
	mov es,ax
	push cs
	pop ds
	xor di,di
	mov si,offset @1
	mov cx,80
	cld
	rep movsw
@3:
end;

procedure SwapScr(W1: word); assembler;
asm
	call GetScrSeg
	jc @4
	mov ds,ax
	xor si,si
	push cs
	pop es
	mov di,offset SwapScrSave+3
	mov cx,80
	cld
	rep movsw
	push ds
	pop es
	push cs
	pop ds
	xor di,di
	mov cx,80
	mov ax,05F20h
	rep stosw
	mov si,W1
	mov cx,ds:[si]
	and cl,11111110b
	add si,2
	mov di,80
	sub di,cx
@3:
	cmp byte ptr ds:[si],0
	jz @4
	movsb
	inc di
	jmp @3
@4:
end;

procedure StrComp; assembler;
asm
	PUSH	SI
	CLD
	MOV	SI,DI
	MOV	CX,0FFFFH
	XOR	AX,AX
	CWD
	REPNE	SCASB
	NOT	CX
	DEC	CX
	MOV	DI,SI
	MOV	SI,8
	REPE	CMPSB
	MOV	AL,DS:[SI-1]
	MOV	DL,ES:[DI-1]
	XOR	DH,DH
	SUB	AX,DX
	OR	AX,AX
	POP	SI
end;

procedure Resident; assembler;
asm
	mov al,SpyInt
	mov byte ptr cs:@SpyInt,al

	mov ax,cs
	mov ds,ax
	mov es,ax
	call @GetDosInUseFlag
	call @SwapAll

	mov byte ptr cs:@InUse,0
	mov byte ptr cs:@ActiveFlag,0

	mov ax,StackLength/16
	mov dx,ss
	mov word ptr cs:@SSPas,dx
	sub dx,Seg @Code
	add dx,ax
	add dx,10h

	mov ax,3100h
	int 21h


@SwapTab:
	db 08h	{Timer}
	dw @Int08Hand,@SaveInt08

	db 09h  {Keyboard}
	dw @Int09Hand,@SaveInt09

	db 13h	{Disk Input/Output}
	dw @Int13Hand,@SaveInt13

	db 25h	{Absolute Disk Read}
	dw @Int25Hand,@SaveInt25

	db 26h	{Absolute Disk Write}
	dw @Int26Hand,@SaveInt26
@SpyInt:
	db 0
	dw @IntSpyHand,@SaveIntSpy
@SwapTabEnd:


@ReleaseCnt:
	mov al,byte ptr cs:@SpyInt
	cmp al,08h
	jz @RC1
	cmp al,09h
	jz @RC1
	cmp al,13h
	jz @RC1
	cmp al,25h
	jz @RC1
	cmp al,26h
	jnz @RC2
@RC1:	mov ax,SwapVectorsCnt-1
	ret
@RC2:	mov ax,SwapVectorsCnt;
	ret

@TestPSP:
	push ds
	push es
	push di
	push ax
	push bx
	push cx
	push dx
	mov ah,62h
	int 21h
	dec bx
	mov ds,bx
	push cs
	pop es

	mov di,offset FileName
	call StrComp

	pop dx
	pop cx
	pop bx
	pop ax
	pop di
	pop es
	pop ds
	ret

@IntSpyHand:
	pushf
	push bp
	mov bp,sp
	push ax
	push ds

	push ax
	mov ax,Seg @Data
	mov ds,ax
	pop ax

	cmp word ptr BufScan,BufMax
	jnc @IntSpyOverFlow

	cmp byte ptr cs:@InUse,0
	jnz @IntSpyOverFlow

	mov byte ptr cs:@InUse,1

	call @TestPSP

	mov byte ptr cs:@InUse,0

	jnz @IntSpyOverFlow

	push ax
	push bx
	mov ax,ss:[bp+4]
	mov bx,ss:[bp+6]
	lea bp,Buf
	add bp,BufS
	mov ds:[bp+0],ax
	mov ds:[bp+2],bx
	pop bx
	pop ax

	mov ds:[bp+4],ax
	mov ds:[bp+6],bx
	mov ds:[bp+8],cx
	mov ds:[bp+10],dx
	mov ds:[bp+12],si
	mov ds:[bp+14],di
	mov ds:[bp+16],es
	pop ax
	mov ds:[bp+18],ax {ds}
	push ax
	mov ds:[bp+20],sp
	mov ds:[bp+22],ss

	add word ptr BufS,24
	inc BufScan
@IntSpyOverFlow:
	pop ds
	pop ax
	pop bp
	popf

	jmp dword ptr cs:@SaveIntSpy


@SaveInt08:
	dd 0
@SaveInt09:
	dd 0
@SaveInt13:
	dd 0
@SaveInt21:
	dd 0
@SaveInt23:
	dd 0
@SaveInt25:
	dd 0
@SaveInt26:
	dd 0
@SaveIntSpy:
	dd 0
@Release:
	db 0
@InUse:
	db 0
@ActiveFlag:
	db 0
@HotKeyPress:
	db 0
@KeyInt:
	db 0
@DosInUseFlag:
	dd 0
@SSPas:
	dw 0
@SPSave:
	dw 0
@SSSave:
	dw 0


@TestActive:
	push ds
	push bx
	push ax
	mov al,byte ptr cs:@ActiveFlag
	lds bx,dword ptr cs:@DosInUseFlag
	add al,[bx]
	cmp al,0
	pop ax
	pop bx
	pop ds
	ret

@Int08Hand:
	pushf
	call dword ptr @SaveInt08

	cmp byte ptr cs:@HotKeyPress,1
	jz @Tim1
	iret

@Tim1:
	cmp byte ptr cs:@InUse,0
	jz @Tim2
	iret

@Tim2:
	call @TestActive
	jz @Tim3
	iret
@Tim3:
	mov byte ptr cs:@InUse,1
	call @Run
	mov byte ptr cs:@HotKeyPress,0
	mov byte ptr cs:@InUse,0
	iret

@Int09Hand:
	or byte ptr cs:@ActiveFlag,10h
	cmp byte ptr cs:@InUse,0
	jnz @Key0
	sti
	push ax
	push bx
	push ds
	in al,60h
	mov bl,al
	cmp al,1
	jnz @Key1

	mov ah,2
	int 16h

	and al,0Fh
	cmp al,8
	jz @Key3
	cmp al,12
	jz @Key4
@Key1:
	pop ds
	pop bx
	pop ax
@Key0:
	pushf
	sti
	call dword ptr @SaveInt09
	and byte ptr cs:@ActiveFlag,0EFh
	iret

@Key4:
	mov byte ptr cs:@Release,1
@Key3:
	mov byte ptr cs:@HotKeyPress,1
	in al,61h
	mov ah,al
	or al,80h
	out 61h,al
	xchg ah,al
	out 61h,al
	mov al,20h
	out 20h,al
	pop ds
	pop bx
	pop ax
	and byte ptr cs:@ActiveFlag,0EFh
	iret

@Int13Hand:
	pushf
	or byte ptr cs:@ActiveFlag,1
	popf
	pushf
	call dword ptr @SaveInt13
	pushf
	and byte ptr cs:@ActiveFlag,0FEh
	popf
	sti
	db 0CAh,02h,00h	{ret far 0002}

@Int25Hand:
	pushf
	or byte ptr cs:@ActiveFlag,00000010b
	popf
	call dword ptr @SaveInt25
	pushf
	and byte ptr cs:@ActiveFlag,11111101b
	popf
	retf

@Int26Hand:
	pushf
	or byte ptr cs:@ActiveFlag,00000100b
	popf
	call dword ptr @SaveInt26
	pushf
	and byte ptr cs:@ActiveFlag,11111011b
	popf
	retf

@SwapVec:
	push bx
	push es
	push ds
	push dx
	push ax
	push di
	mov ah,35h
	int 21h
	pop di
	mov cs:[di],bx
	mov cs:[di+02],es
	pop ax
	pop dx
	push cs
	pop ds
	mov ah,25h
	int 21h
	pop ds
	pop es
	pop bx
	ret


@Run:
	push es
	push ds
	push ax
	push bx
	push cx
	push dx
	push si
	push di
	push bp

	cmp byte ptr cs:@Release,0
	jz @Run1
	call @TestRelease
	or al,al
	jnz @Run3
	mov ax,offset Mes3
	jmp @Run4
@Run3:
	call @ReleaseProc
	mov ax,offset Mes2
@Run4:
	push ax
	call SwapScr
	xor ax,ax
	int 16h
	jmp @Run2
@Run1:
	push cs
	pop ds

	mov word ptr ds:@SPSave,sp
	mov word ptr ds:@SSSave,ss

	cli
	mov ss,word ptr ds:@SSPas
	mov sp,StackLength-16
	sti

	mov ax,offset Mes1
	push ax
	call SwapScr

	mov ax,Seg @Data
	mov ds,ax
	mov es,ax

	call main

	cli
	mov ss,word ptr cs:@SSSave
	mov sp,word ptr cs:@SPSave
	sti
@Run2:
	call SwapScrSave

	pop bp
	pop di
	pop si
	pop dx
	pop cx
	pop bx
	pop ax
	pop ds
	pop es
	ret

@GetDosInUseFlag:
	cld
	mov ah,34h
	int 21h
	mov word ptr cs:@DosInUseFlag,bx
	mov word ptr cs:@DosInUseFlag+2,es
	ret

@ReleaseProc:
	push ds
	call @ReleaseCnt
	mov cx,ax
	mov si,offset @SwapTab
@ReleaseLoop:
	mov al,cs:[si]
	mov di,cs:[si+3]
	lds dx,dword ptr cs:[di]
	mov ah,25h
	int 21h
	add si,5
	loop @ReleaseLoop

	mov si,cs
	sub si,10h
	mov ah,52h
	int 21h
	mov ds,es:[bx-2]
@Release1:
	cmp si,[1]
	jnz @Release2
	mov ax,ds
	inc ax
	mov es,ax
	mov ah,49h
	int 21h
@Release2:
	mov ax,ds
	inc ax
	add ax,[3]
	cmp byte ptr ds:[0],4dh
	mov ds,ax
	jz @Release1

	pop ds
	ret

@TestRelease:
	push ds
	call @ReleaseCnt
	mov cx,ax
	mov si,offset @SwapTab
@RelTestLoop:
	mov al,cs:[si]
	mov ah,35h

	int 21h
@RelTest2:
	mov ax,es
	mov di,cs
	cmp di,ax
	jnz @ReleaseErr
	add si,5
	loop @RelTestLoop
	mov ax,1
	jmp @ReleaseOK
@ReleaseErr:
	xor ax,ax
@ReleaseOK:
	pop ds
	ret

@SwapAll:
	mov cx,SwapVectorsCnt
	mov bx,offset @SwapTab
@SwapLoop:
	mov al,cs:[bx]
	mov dx,cs:[bx+1]
	mov di,cs:[bx+3]
	call @SwapVec
	add bx,5
	loop @SwapLoop
end;

function CalcExeName: string;
var
FDir: DirStr;
FName: NameStr;
DExt: ExtStr;
begin
	FSplit(ParamStr(0),FDir,FName,FExt);
	CalcExeName:=FDir+FName;
end;

function HexByte(B:byte):string; assembler;
asm
	les di,@Result
	cld
	mov ax,2
	stosb
	xor bx,bx
	mov bl,B
	shr bl,1
	shr bl,1
	shr bl,1
	shr bl,1
	mov al,[bx + offset HexChars]
	mov bl,[B]
	and bx,0fh
	mov ah,[bx + offset HexChars]
	stosw
end;

function HexWord(W:word):string; assembler;
asm
	les di,@Result
	cld
	mov ax,4
	stosb
	mov dx,W
	mov cx,dx
	and cx,0f0fh
	and dx,0f0f0h
	shr dx,1
	shr dx,1
	shr dx,1
	shr dx,1
	xor bx,bx
	mov bl,dh
	mov al,[bx + offset HexChars]
	mov bl,ch
	mov ah,[bx + offset HexChars]
	stosw
	mov bl,dl
	mov al,[bx + offset HexChars]
	mov bl,cl
	mov ah,[bx + offset HexChars]
	stosw
end;

procedure  main;
var
f: text;
i,j: word;
Str1: string;
begin
	SwapVectors;
	assign(f,CalcExeName+'.rep');
	rewrite(f);
	writeln(f,'***** '+PName+' report about calling INT '+HexByte(SpyInt)+'h from program '+FName+' *****');
	writeln(f);
	if BufScan>0 then
	 for i:=0 to BufScan-1 do
	  begin
	   writeln(f,'-----------------------------------');
	   writeln(f,'Calling from '+HexWord(Buf[i].CallSeg)+':'+HexWord(Buf[i].CallOffs-2));
	   writeln(f,'AX='+HexWord(Buf[i].RAX));
	   writeln(f,'BX='+HexWord(Buf[i].RBX));
	   writeln(f,'CX='+HexWord(Buf[i].RCX));
	   writeln(f,'DX='+HexWord(Buf[i].RDX));
	   writeln(f,'SI='+HexWord(Buf[i].RSI));
	   writeln(f,'DI='+HexWord(Buf[i].RDI));
	   writeln(f,'ES='+HexWord(Buf[i].RES));
	   writeln(f,'DS='+HexWord(Buf[i].RDS));
	   writeln(f,'SP='+HexWord(Buf[i].RSP));
	   writeln(f,'SS='+HexWord(Buf[i].RSS));
	  end;
	writeln(f,'-----------------------------------');
	close(f);
	BufS:=0;
	BufScan:=0;
	SwapVectors;
end;

procedure UCase(var Str1: string);
var
i: byte;
begin
	for i:=1 to Byte(Str1[0]) do Str1[i]:=UpCase(Str1[i]);
end;

procedure wln(Str1: string);
begin
	writeln(Str1);
end;

begin
	FSplit(CalcExeName,FDir,FName,FExt);
	PName:=FName;
	UCase(PName);
	wln(PName+' V1.0  Nick Walter computing (c)1993 TurboSoft');
	if ParamStr(1)='' then
	 begin
	  wln('Usage: '+PName+' interrupt(hex) ProgramName(without extention)'+#13#10+
	       PName+' will stay resident'+#13#10+
	      'Then press <Alt-Esc> and look report file - '+PName+'.REP'+#13#10+
	      'To remove '+PName+' from memory press <Ctrl-Alt-Esc> (not <Ctrl-Alt-Del> [:-)] )');
	  halt;
	 end;
	val('$'+ParamStr(1),i,j);
	Str1:=ParamStr(2);
	UCase(Str1);
	FSplit(Str1,FDir,FName,FExt);
	if FName='' then j:=1;
	if (i>255) or (j<>0) then
	 begin
	  wln('Command line error');
	  halt;
	 end;
	SpyInt:=i;
	move(FName[1],@FileName^,length(FName));
	SwapVectors;
	Resident
end.
